#ifndef __BRUS_SLV_H__
#define __BRUS_SLV_H__
#include "utils.h"

#define bruss_fwd_trace_Df_timedep_part(nlx,nly)  ((nlx)*2.0*(nly) - (nlx)*1.0*(nlx))

extern double          hj1,j00,j10,j11,j01,j011,j101,j110,j111,j1111;
extern unsigned long   until_stationary;
extern random_set      gauss1;



void Brus_nonlinear_ord_2 (double x_start, double *x_new, 
                           double y_start, double *y_new,
                           double dt, double alpha, double beta, double sigma);

void Brus_nonlinear_ord2_fwd_for_grid (double *xini, double *yini, 
				       double dt, 
				       double alpha, double beta, double sigma);

void Brus_linear_ord_2 (double x_start, double x0, double *x_new, 
                        double y_start, double y0, double *y_new, 
                        double dt, double beta, double sigma);

void brus_nonlinear_ord2_bwd (double x_start, double *x_new, 
			      double y_start, double *y_new,
			      double dt, double alpha, double beta, double sigma);

void brus_lin_ord2_bwd (double x_start, double x0, double *x_new, 
                        double y_start, double y0, double *y_new, 
                        double dt, double beta, double sigma);

void Brus_nonlinear_ord2_bwd_for_grid (double *xini, double *yini, 
				       double dt, 
				       double alpha, double beta, double sigma);


void compute_j_functionals(random_set *ptr_rs, double time_step);
void compute_stationary_nl_solution ( double alpha,
				      double beta,
				      double sigma,
				      double dt,
				      double nlx1_s,
				      double nlx2_s,
				      double nly1_s,
				      double nly2_s,
				      FILE   *fp_log,
				      int    modulus,
				      double *nlx_stat,
				      double *nly_stat
				      );


#endif
