#ifndef __J_H__
#define __J_H__

typedef struct {
              double xi;
              double eta[20];
              double zeta[20];
	    } random_set;


/*  definition of the external variables,      */      
/*  especially of the routines for the         */ 
/*  multiintegrals                             */

extern double j_1(random_set* rs1,double dt);

extern double j_0(double dt);
extern double j_00(double dt);
extern double j_11(random_set* rs1,double dt);
extern double j_12(random_set* rs1,random_set* rs2,double dt);

extern double j_10(random_set* rs1,double dt);
extern double j_01(random_set* rs1,double dt);
extern double j_111(random_set* rs1,double dt);
extern double j_112(random_set* rs1,random_set* rs2,double dt);
extern double j_121(random_set* rs1,random_set* rs2,double dt);
extern double j_211(random_set* rs1,random_set* rs2,double dt);
extern double j_123(random_set* rs1,random_set* rs2,random_set* rs3,double dt);

extern double j_110(random_set* rs1,double dt);
extern double j_101(random_set* rs1,double dt);
extern double j_011(random_set* rs1,double dt);
extern double j_120(random_set* rs1,random_set* rs2,double dt);
extern double j_102(random_set* rs1,random_set* rs2,double dt);
extern double j_012(random_set* rs1,random_set* rs2,double dt);
extern double j_1111(random_set* rs1,double dt);
extern double j_1112(random_set* rs1,random_set* rs2,double dt);
extern double j_1121(random_set* rs1,random_set* rs2,double dt);
extern double j_1211(random_set* rs1,random_set* rs2,double dt);
extern double j_2111(random_set* rs1,random_set* rs2,double dt);
extern double j_1122(random_set* rs1,random_set* rs2,double dt);
extern double j_1212(random_set* rs1,random_set* rs2,double dt);
extern double j_1221(random_set* rs1,random_set* rs2,double dt);
extern double j_2112(random_set* rs1,random_set* rs2,double dt);
extern double j_1123(random_set* rs1,random_set* rs2,\
                     random_set* rs3,double dt);
extern double j_1234(random_set* rs1,random_set* rs2,\
                     random_set* rs3,random_set* rs4,double dt);

extern double j_100(random_set* rs1,double dt);
extern double j_010(random_set* rs1,double dt);
extern double j_001(random_set* rs1,double dt);
extern double j_1110(random_set* rs1,double dt);
extern double j_1101(random_set* rs1,double dt);
extern double j_1011(random_set* rs1,double dt);
extern double j_1111(random_set* rs1,double dt);
extern double j_11111(random_set* rs1,double dt);

extern double j_1100(random_set* rs1,double dt);
extern double j_1010(random_set* rs1,double dt);
extern double j_0110(random_set* rs1,double dt);
extern double j_1001(random_set* rs1,double dt);
extern double j_0101(random_set* rs1,double dt);
extern double j_0011(random_set* rs1,double dt);
extern double j_11110(random_set* rs1,double dt);
extern double j_11101(random_set* rs1,double dt);
extern double j_11011(random_set* rs1,double dt);
extern double j_10111(random_set* rs1,double dt);
extern double j_01111(random_set* rs1,double dt);
extern double j_111111(random_set* rs1,double dt);


/*  definition of the init-function & the fill-function       */


extern void gauss_init(long seed);
extern void fill_gauss(random_set* rs1);
extern void set_gauss(long iter_start);
extern void set_seed(long s);
extern long get_seed(void);

#endif /* __J_H__ */
