#ifndef __UTILS_H__
#define __UTILS_H__

#include <stdio.h>
#include <values.h>

#include "j.h"

#if defined(__MSDOS__) || (__WIN32__)
#ifndef __rand48__
#define __rand48__
#define drand48()	(rand()/(1.0+RAND_MAX))
#define srand48(s)	srand(s)
#endif
#endif

#define TRUE      1
#define FALSE     0
#define NAMESIZE  80
#define PC	  0
#define SUN	  1000
#define HP        1000
#define round(x)  floor((x)+0.5)
#define sign(x)   ((x>0?1:(x<0?-1:0)))

#define UNTIL_STATIONARY_SEED 87037 /* seed(prime number) for stationary solution */
#define EPS_DIFF_X 1e-8             /* for stationary solution */
#define EPS_DIFF_Y 1e-8             /* for stationary solution */
#define INVALID_PARAM 10000.0       /* for initialization */
#define MAX_SDE  sqrt(sqrt(sqrt(MAXDOUBLE)))
#define SDE_DIMENSION 2 


/*
 * savemat - C language routine to save a matrix in a MAT-file.
 *
 * Here is an example that uses 'savemat' to save two matrices to disk,
 * the second of which is complex:
 *
 *	FILE *fp;
 *	double xyz[1000], ar[1000], ai[1000];
 *	fp = fopen("foo.mat","wb");
 *	savemat(fp, 2000, "xyz", 2, 3, 0, xyz, (double *)0);
 *	savemat(fp, 2000, "a", 5, 5, 1, ar, ai);
 *      fclose(fp);
 *
 * Author J.N. Little 11-3-86
 */

void savemat(FILE *fp, int type, char *pname, int mrows, int ncols,
	     int imagf, double *preal, double *pimag);
     /* FILE *fp;       File pointer */
     /* int type;       Type flag: Normally 0 for PC, 1000 for Sun, Mac, and	 */
     /*                 Apollo, 2000 for VAX D-float, 3000 for VAX G-float    */
     /*                 Add 1 for text variables.	 */
     /*                 See LOAD in reference section of guide for more info. */
     /* char *pname;    pointer to matrix name */
     /* int mrows;      row dimension */
     /* int ncols;      column dimension */
     /* int imagf;	imaginary flag */
     /* double *preal;  pointer to real data */
     /* double *pimag;  pointer to imag data */

void testenv(char *progname);
void *salloc(size_t s);
double norm_euklid(double *vector, int dimension);
double norm_euklid_sqr(double *vector, int dimension);

#endif /* __UTILS_H__ */



























